#TEMPLATE (WillingsScrollABC, 'Optimize Scrolling Behaviour ABC Willings'), FAMILY('ABC')
#!===================================================================
#EXTENSION (OptimizeScroll, 'Only one NewSeletion when Scrolling Up-Down'), PROCEDURE
#!------------------
  #DISPLAY('This Template is offered by Krikor Hovelian from')
  #DISPLAY(' Willings Ltd. Paris, France. http://www.willings.com')
  #DISPLAY('')
  #DISPLAY('When Scrolling Up and Down in a Browse, a lot of events')
  #DISPLAY('are shot by the Accept Loop. Clarion being fast, with')
  #DISPLAY('simple Browses it is acceptable but with complex ones')
  #DISPLAY('where you may have a lot of code in NewSelection Events')
  #DISPLAY('or have several DropLists... these operations are shot at')
  #DISPLAY('each record overrun while Scrolling.')
  #DISPLAY('This Template allows to do all the operation only once.')
  #DISPLAY('When Vertical Scrolling STOPS.')
  #DISPLAY('')
  #DISPLAY('Select the files you whish to optimize at Vertical Scrolling')
  #DISPLAY('')
  #PROMPT ('Choice of LisBox', FROM (%Control, %ControlType='COMBO' OR %ControlType='LIST')), %WillingsBrowses, SELECTION('Select the controls'),INLINE
  #PROMPT ('Reset only Visible Browses', CHECK), %WillingsOptimiseVisible, DEFAULT('1'), AT(10)
#!------------------
#AT (%DataSectionBeforeWindow)
WillingsActiveControl   LONG(0)
WillingsScrollCounter   LONG(0)
#ENDAT
#!------------------
#AT (%ControlEventHandling,%Control,'ScrollUp'),WHERE(INLIST(%Control, %WillingsBrowses)), DESCRIPTION('Willings'' Scroll Optimiser'), PRIORITY(5000)
WillingsActiveControl = %Control
WillingsScrollCounter += 1
#ENDAT
#!------------------
#AT (%ControlEventHandling,%Control,'ScrollDown'),WHERE(INLIST(%Control, %WillingsBrowses)), DESCRIPTION('Willings'' Scroll Optimiser'), PRIORITY(5000)
WillingsActiveControl = %Control
WillingsScrollCounter += 1
#ENDAT
#!------------------
#AT (%ControlEventHandling,%Control,'NewSelection'),WHERE(INLIST(%Control, %WillingsBrowses)), DESCRIPTION('Willings'' Scroll Optimiser'),PRIORITY(2500)
IF WillingsActiveControl = %Control
  IF WillingsScrollCounter > 1
    WillingsScrollCounter -= 1
    CYCLE
  ELSE
    WillingsScrollCounter = 0 
  END
ELSIF WillingsScrollCounter                      
  RETURN Level:Benign
END
#ENDAT
#!------------------
#AT(%WindowManagerMethodCodeSection,'Reset','(BYTE Force=0)'), DESCRIPTION('Willings'' Scroll Optimiser'), PRIORITY(250)
IF WillingsScrollCounter THEN RETURN.
#ENDAT
#!------------------
#AT(%BrowserMethodCodeSection,,'Reset','()'), WHERE(%WillingsOptimiseVisible), DESCRIPTION('Willings'' Visible Optimiser'),PRIORITY(2500)
  #IF(%WillingsOptimiseVisible)
IF NOT %Control{PROP:Visible} AND NOT %Window{PROP:AcceptAll} THEN RETURN.
  #ENDIF
#ENDAT
#!------------------
#AT(%BrowserMethodCodeSection,,'ResetQueue','(BYTE ResetMode)'), WHERE(%WillingsOptimiseVisible), DESCRIPTION('Willings'' Visible Optimiser'), PRIORITY(2500)
  #IF(%WillingsOptimiseVisible)
IF NOT %Control{PROP:Visible} AND NOT %Window{PROP:AcceptAll} THEN RETURN.
  #ENDIF
#ENDAT
#!------------------
